﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:str="http://exslt.org/strings" version="1.0" extension-element-prefixes="str">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
  <xsl:variable name="vLower" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="vUpper" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:template match="/">
    <xsl:comment>This file is automatically generated from gui/wxpython/xml/menudata.xml.</xsl:comment>
    <toolboxes>
      <xsl:call-template name="convertItems">
        <xsl:with-param name="pNode" select="menudata/menubar/menu"/>
      </xsl:call-template>
      <xsl:call-template name="convertItems">
        <xsl:with-param name="pNode" select="menudata/menubar/menu/*/menu"/>
      </xsl:call-template>
    </toolboxes>
  </xsl:template>
  <xsl:template name="convertItems">
    <xsl:param name="pNode"/>
    <xsl:for-each select="$pNode">
      <xsl:element name="toolbox">
        <xsl:attribute name="name">
          <xsl:call-template name="convertLabelsToIdentifiers">
            <xsl:with-param name="pText" select="concat(str:replace(label, '&amp;', ''), ' ')"/>
          </xsl:call-template>
        </xsl:attribute>
        <label>
          <xsl:value-of select="label"/>
        </label>
        <items>
          <xsl:for-each select="items/*">
            <xsl:choose>
              <xsl:when test="name() = 'menuitem' and command and handler='OnMenuCmd'">
                <xsl:element name="module-item">
                  <xsl:attribute name="name">
                    <xsl:value-of select="command"/>
                  </xsl:attribute>
                  <label>
                    <xsl:value-of select="label"/>
                  </label>
                </xsl:element>
              </xsl:when>
              <xsl:when test="name() = 'menuitem' and not(handler='OnMenuCmd')">
                <xsl:element name="wxgui-item">
                  <xsl:attribute name="name">
                    <xsl:call-template name="convertLabelsToIdentifiers">
                      <xsl:with-param name="pText" select="concat(translate(str:replace(str:replace(str:replace(label, '&amp;', ''), 'Tcl/Tk', 'TclTk'), 'Create/edit', 'CreateOrEdit'), '()', ''), ' ')"/>
                    </xsl:call-template>
                  </xsl:attribute>
                </xsl:element>
              </xsl:when>
              <xsl:when test="name() = 'separator'">
                <separator/>
              </xsl:when>
              <xsl:when test="name() = 'menu'">
                <xsl:element name="subtoolbox">
                  <xsl:attribute name="name">
                    <!--<xsl:value-of select="translate(label, ' ', '')"/>-->
                    <xsl:call-template name="convertLabelsToIdentifiers">
                      <xsl:with-param name="pText" select="concat(str:replace(label, '&amp;', ''), ' ')"/>
                    </xsl:call-template>
                  </xsl:attribute>
                </xsl:element>
              </xsl:when>
              <xsl:otherwise>
                <xsl:message terminate="yes">Error: Unsupported type in items list.</xsl:message>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:for-each>
        </items>
      </xsl:element>
    </xsl:for-each>
  </xsl:template>
  <xsl:template name="convertLabelsToIdentifiers">
    <xsl:param name="pText"/>
    <xsl:if test="$pText">
      <xsl:value-of select="translate(substring($pText,1,1), $vLower, $vUpper)"/>
      <xsl:value-of select="substring-before(substring($pText,2), ' ')"/>
      <xsl:call-template name="convertLabelsToIdentifiers">
        <xsl:with-param name="pText" select="substring-after(substring($pText,2), ' ')"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
