﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:str="http://exslt.org/strings" version="1.0" extension-element-prefixes="str">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
  <xsl:variable name="vLower" select="'abcdefghijklmnopqrstuvwxyz'"/>
  <xsl:variable name="vUpper" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>
  <xsl:template match="/">
    <xsl:comment>This file is automatically generated from gui/wxpython/xml/menudata.xml. However, for the wxGUI with toolboxes it will not be generated.</xsl:comment>
    <wxgui-items>
      <xsl:call-template name="convertItems">
        <xsl:with-param name="pNode" select="menudata/menubar/menu/items/menuitem"/>
      </xsl:call-template>
      <xsl:call-template name="convertItems">
        <xsl:with-param name="pNode" select="menudata/menubar/menu/items/menu/items/menuitem"/>
      </xsl:call-template>
    </wxgui-items>
  </xsl:template>
  <xsl:template name="convertItems">
    <xsl:param name="pNode"/>
    <xsl:for-each select="$pNode">
      <xsl:if test="not(handler='OnMenuCmd')">
        <xsl:element name="wxgui-item">
          <xsl:attribute name="name">
            <xsl:call-template name="convertLabelsToIdentifiers">
              <xsl:with-param name="pText" select="concat(translate(str:replace(str:replace(str:replace(label, '&amp;', ''), 'Tcl/Tk', 'TclTk'), 'Create/edit', 'CreateOrEdit'), '()', ''), ' ')"/>
            </xsl:call-template>
          </xsl:attribute>
          <label>
            <xsl:value-of select="label"/>
          </label>
          <xsl:choose>
            <xsl:when test="handler='RunMenuCmd'">
              <command>
                <xsl:value-of select="command"/>
              </command>
            </xsl:when>
            <xsl:otherwise>
              <handler>
                <xsl:value-of select="handler"/>
              </handler>
              <xsl:if test="command">
                <related-module>
                  <xsl:value-of select="command"/>
                </related-module>
              </xsl:if>
            </xsl:otherwise>
          </xsl:choose>
          <description>
            <xsl:value-of select="help"/>
          </description>
          <xsl:if test="keywords">
            <keywords>
              <xsl:value-of select="keywords"/>
            </keywords>
          </xsl:if>
          <xsl:if test="shortcut">
            <shortcut>
              <xsl:value-of select="shortcut"/>
            </shortcut>
          </xsl:if>
          <xsl:if test="id">
            <wx-id>
              <xsl:value-of select="id"/>
            </wx-id>
          </xsl:if>
        </xsl:element>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>
  <xsl:template name="convertLabelsToIdentifiers">
    <xsl:param name="pText"/>
    <xsl:if test="$pText">
      <xsl:value-of select="translate(substring($pText,1,1), $vLower, $vUpper)"/>
      <xsl:value-of select="substring-before(substring($pText,2), ' ')"/>
      <xsl:call-template name="convertLabelsToIdentifiers">
        <xsl:with-param name="pText" select="substring-after(substring($pText,2), ' ')"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
